PGSQL_CONTROL
-- $Id: aggregatex.m4,v 1.14 2006/04/06 00:23:10 babolo Exp $

--  
CREATE AGGREGATE cat
     ( BASETYPE = text
     , SFUNC = textcat
     , STYPE = text
     , INITCOND = ''
     )
;
COMMENT ON AGGREGATE cat(text)           IS ' ';



--  bool  AND  OR --
---------------------------------
CREATE OR REPLACE FUNCTION bool_and(bool, bool) RETURNS bool
 AS 'SELECT $1 AND $2'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bool_and(bool, bool) IS '        ';

CREATE OR REPLACE FUNCTION bool_or(bool, bool) RETURNS bool
 AS 'SELECT $1 OR $2'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bool_or(bool, bool)  IS '        ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bool
     , SFUNC = bool_and
     , STYPE = bool
     , INITCOND = 1
     )
;
COMMENT ON AGGREGATE conjunction(bool)   IS ' AND  bool';

CREATE AGGREGATE disjunction
     ( BASETYPE = bool
     , SFUNC = bool_or
     , STYPE = bool
     , INITCOND = 0
     )
;
COMMENT ON AGGREGATE disjunction(bool)   IS ' OR  bool';



--    --
------------------------------
CREATE OR REPLACE FUNCTION bitex0(bit, int4) RETURNS varbit
 AS 'SELECT pg_catalog.bit($1, $2, TRUE)'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex0(bit, int4) IS '   ,    0';

CREATE OR REPLACE FUNCTION bitex1(bit, int4) RETURNS varbit
 AS 'SELECT CASE WHEN bit_length($1) > $2
                 THEN pg_catalog.bit($1, $2, TRUE)
                 WHEN bit_length($1) < $2
                 THEN bitcat($1, bitnot(pg_catalog.bit(''0''::varbit, $2 - bit_length($1), TRUE)))
                 ELSE $1
            END
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION bitex1(bit, int4) IS '   ,    1';



--  varbit  bool  AND  OR --
---------------------------------------
CREATE OR REPLACE FUNCTION boolor(varbit) RETURNS bool
 AS 'SELECT $1 <> bitex0(''''::varbit, bit_length($1))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION boolor(varbit)       IS 'OR    ';

CREATE OR REPLACE FUNCTION booland(varbit) RETURNS bool
 AS 'SELECT $1 = ~bitex0(''''::varbit, bit_length($1))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION booland(varbit)      IS 'AND    ';



--    , ,            --
--    ,    --
------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION varbiteq(bit, bit) RETURNS bool
 AS 'SELECT bitex0($1, l) = bitex0($2, l)
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbiteq(bit, bit)   IS '    ';

CREATE OR REPLACE FUNCTION varbitand(bit, bit) RETURNS varbit
 AS 'SELECT bitand(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l2 ELSE l1 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitand(bit, bit)  IS 'AND      ';

CREATE OR REPLACE FUNCTION varbitor(bit, bit) RETURNS varbit
 AS 'SELECT bitor(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitor(bit, bit)   IS 'OR      ';

CREATE OR REPLACE FUNCTION varbitxor(bit, bit) RETURNS varbit
 AS 'SELECT bitxor(bitex0($1, l), bitex0($2, l))
      FROM (SELECT CASE WHEN l1 > l2 THEN l1 ELSE l2 END AS l
             FROM (SELECT bit_length($1) AS l1, bit_length($2) AS l2)i
           )d
    '
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitxor(bit, bit)  IS 'XOR      ';

CREATE OR REPLACE FUNCTION varbitrst(bit, bit) RETURNS varbit
 AS 'SELECT bitand($1, ~bitex0($2, bit_length($1)))'
 LANGUAGE SQL IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbitrst(bit, bit)  IS '$1 AND ~$2,       ';

CREATE OPERATOR ==
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbiteq
     , COMMUTATOR = ==
     )
;
COMMENT ON OPERATOR == (bit, bit)        IS '    ';

CREATE OPERATOR /|
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitand
     , COMMUTATOR = /|
     )
;
COMMENT ON OPERATOR /| (bit, bit)        IS 'AND      ';

CREATE OPERATOR |/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitor
     , COMMUTATOR = |/
     )
;
COMMENT ON OPERATOR |/ (bit, bit)        IS 'OR      ';

CREATE OPERATOR ^
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = ^
     )
;
COMMENT ON OPERATOR ^ (bit, bit)         IS 'XOR      ';

CREATE OPERATOR !
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitrst
     )
;
COMMENT ON OPERATOR ! (bit, bit)         IS '$1 AND ~$2,       ';



--  varbit  AND  OR --
-----------------------------------
CREATE OR REPLACE FUNCTION varbitandN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitand($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION varbitandN(bit, bit) IS 'varbitand  ';

CREATE OR REPLACE FUNCTION varbitorN(bit, bit) RETURNS varbit
 AS 'SELECT CASE WHEN $1 IS NULL THEN $2 WHEN $2 IS NULL THEN $1 ELSE varbitor($1, $2) END
    '
 LANGUAGE SQL IMMUTABLE
;
COMMENT ON FUNCTION varbitorN(bit, bit)  IS 'varbitor  ';

CREATE AGGREGATE conjunction
     ( BASETYPE = bit
     , SFUNC = varbitandN
     , STYPE = varbit
     )
;
COMMENT ON AGGREGATE conjunction(bit)    IS ' AND  bit';

CREATE AGGREGATE disjunction
     ( BASETYPE = bit
     , SFUNC = varbitorN
     , STYPE = varbit
     )
;
COMMENT ON AGGREGATE disjunction(bit)    IS ' OR  bit';



--          --
---------------------------------------------------------------
CREATE OR REPLACE FUNCTION num2bit(varbit, integer) RETURNS varbit
 AS '$libdir/num2bit.so.VMAJOR'
  , 'num2bit'
 LANGUAGE C IMMUTABLE STRICT
;
CREATE OR REPLACE FUNCTION num2bit(integer) RETURNS varbit
 AS 'SELECT num2bit(''''::varbit, $1)'
 LANGUAGE SQL IMMUTABLE STRICT
;
CREATE AGGREGATE num2bit_aggr
    ( BASETYPE = integer
    , SFUNC = num2bit
    , STYPE = varbit
    , INITCOND = 0
    )
;
CREATE OR REPLACE FUNCTION bit2num(varbit) RETURNS SETOF int4
 AS '$libdir/num2bit.so.VMAJOR'
  , 'bit2num'
 LANGUAGE C IMMUTABLE STRICT
;
COMMENT ON FUNCTION bit2num(varbit)       IS '   ,        ,       ';



--       --
------------------------------------------
CREATE FUNCTION varbit2numstr(varbit, text) RETURNS text
 AS 'DECLARE
        str  text;
        i    RECORD;
     BEGIN
        FOR i IN SELECT bit2num($1)
        LOOP
           IF str IS NULL
           THEN str := i.bit2num;
           ELSE str := str || $2 || i.bit2num;
           END IF;
        END LOOP;
        RETURN str;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text)
 IS '   ,    .    $2'
;
CREATE OR REPLACE FUNCTION varbit2numstr(varbit, text, text) RETURNS text
 AS 'DECLARE
        num      int;
        num_prev int;
        fl       int;
        str      text;
        i        RECORD;
     BEGIN
        num_prev := 0;
        fl := 0;
        FOR i IN SELECT bit2num($1)
        LOOP
           num := i.bit2num;
           IF str IS NULL
           THEN str := num;
           ELSIF num = num_prev + 1 AND fl = 0
           THEN
              str := str || $3;
              fl := 1;
           ELSIF num <> num_prev + 1 AND fl = 1
           THEN
              str := str || num_prev || $2 || num;
              fl := 0;
           ELSIF fl = 0
           THEN str := str || $2 || num;
           END IF;
           num_prev := num;
        END LOOP;
        IF fl = 0
        THEN RETURN str;
        ELSE RETURN str || num;
        END IF;
     END;
    '
 LANGUAGE 'plpgsql' IMMUTABLE STRICT
;
COMMENT ON FUNCTION varbit2numstr(varbit, text, text)
 IS '   ,    .    $2,    $3'
;



-- ,   --
--------------------------
CREATE OPERATOR /|/
     ( LEFTARG = bit
     , RIGHTARG = bit
     , PROCEDURE = varbitxor
     , COMMUTATOR = /|/
     )
;
CREATE OR REPLACE FUNCTION bitreset(varbit, int4) RETURNS varbit
 AS 'SELECT varbitrst($1, num2bit($2))'
 LANGUAGE SQL IMMUTABLE STRICT
;
